-- Replace all built wooden chests with steel chests.
local function on_built_entity_for_replacement(event)
	if event.created_entity.name == "wooden-chest" then
		-- Record data about the chest.
		local surface = event.created_entity.surface
		local position = event.created_entity.position
		local force = event.created_entity.force
		
		-- Destroy the wooden chest.
		-- THIS IS WHERE THE ERROR IS CAUSED.
		event.created_entity.destroy()
		
		-- Place a steel chest.
		surface.create_entity
		{
			name = "steel-chest",
			position = position,
			force = force
		}
		
		-- No need to raise on_built_entity because we know what we are doing.
	end
end

script.on_event(defines.events.on_built_entity,			on_built_entity_for_replacement)
script.on_event(defines.events.on_robot_built_entity,	on_built_entity_for_replacement)